; -   www.kulakov.ru, vk@jeo.ru
;        




; :  HS, WDT disable, PWRT enable, BODEN enable, RB3 digital I/O,
;BKBUG disable.     20 

;  :
;        ,     .
; 1... 10    0... 9.         
;"".       12.      (  TxByte), 
;  "" .       11,     
;      ""  (..    ).
;     13,        (
;  TxByte)        ,     .
;    16    TxByte.   14  15 
;     TxByte     .
;   .
;      .           "".
;   .









#include p16f877.inc





 
;, 0
	cblock 0x20	

	CntLo		;   
	CntHi		;



	RecByte		;     
	TxByte		;    
	Tx_Byte		;         SCI_Tx



	Mul1Lo		;      Mul16_8   Div10
	Mul1Hi		;
	ResHi		;
	DivLo		;
	DivHi		;
	Mul2		;
	

	Flag		; 


	ButPressed0	;  
	ButPressed1	;


	Temp		;   (   )
	Temp1		;
	Temp2		;
	Temp3		;
	Temp4		;




	Fig0		;    . Fig0,Fig1 -   ,
	Fig1		;Fig2 -   (   )   (  )
	Fig2		;


	IndVal		;     
	Latch		;
	CntInd		;


	CntNab		;       Nabor
	FigNab0		;
	FigNab1		;
	FigNab2		;
	TempNab		;



	endc





; 16 :	
W_TEMP		EQU	7Dh	;   STATUS, W  PCLATH  
STATUS_TEMP 	EQU	7Eh	;
PCLATH_TEMP	EQU	7Fh	;





;

Clock			EQU	.20000000	;  
DesiredBaudRate		EQU	.2400		;C   RS232


;     :
INIT_PORTA		EQU	b'00000000'	;   
INIT_PORTB		EQU	b'00001111'	;   
INIT_PORTC		EQU	b'10000000'	;RC7 -     
INIT_PORTD		EQU	b'00000000'	; 
INIT_PORTE		EQU	b'00000000'	; 
INIT_OPTION		EQU	b'00000000'	;  
INIT_INTCON		EQU	b'11000000'	;  
INIT_PIE1		EQU	b'00100000'	;      
INIT_T1CON		EQU	b'00000000'	; 1 






;     SCI,      :
#define	rcif	PIR1,RCIF
#define	txif	PIR1,TXIF
#define	spen	RCSTA,SPEN
#define	oerr	RCSTA,OERR
#define	rx8_9	RCSTA,RC8_9
#define	cren	RCSTA,CREN
#define	ferr	RCSTA,FERR
#define sync	TXSTA^80h,SYNC
#define brgh	TXSTA^80h,BRGH
#define tx8_9	TXSTA^80h,TX8_9
#define txen	TXSTA^80h,TXEN



; Flag:
#define BtPrs		Flag,0		;  1   
#define HaveByte	Flag,1		;  1     SCI


#define Bt0	ButPressed0,0		;   ( 1)
#define Bt1	ButPressed0,1		;
#define Bt2	ButPressed0,2		;
#define Bt3	ButPressed0,3		;
#define Bt4	ButPressed0,4		;
#define Bt5	ButPressed0,5		;
#define Bt6	ButPressed0,6		;
#define Bt7	ButPressed0,7		;
#define Bt8	ButPressed1,0		;
#define Bt9	ButPressed1,1		;
#define Bt10	ButPressed1,2		;
#define Bt11	ButPressed1,3		;
#define Bt12	ButPressed1,4		;
#define Bt13	ButPressed1,5		;
#define Bt14	ButPressed1,6		;
#define Bt15	ButPressed1,7			;( 16)


#define	Data_in	PORTE,1			;    
#define	Clk	PORTE,0			;     

#define		Col0	PORTB,0		;    
#define		Col1	PORTB,1		;
#define		Col2	PORTB,2		;
#define		Col3	PORTB,3		;
#define		Line0	PORTB,4		;
#define		Line1	PORTB,5		;
#define		Line2	PORTB,6		;
#define		Line3	PORTB,7		;


;*****************************  *********************************

	goto Begin	;  

Intrp	org	0x4	; 

	MOVWF W_TEMP		; W, STATUS  PCLATH 
	SWAPF STATUS,W 		;
	CLRF STATUS		;
	MOVWF STATUS_TEMP 	;
	MOVF PCLATH, W 		;
	MOVWF PCLATH_TEMP	;
	CLRF PCLATH 		;


	btfss rcif
	goto rett
	
Int_Rx			;   

	btfsc oerr	;
	goto Rx_Err	;
	btfsc ferr	;
	goto Rx_Err	;  STOP

	movf RCREG,0	;  
	movwf RecByte	;

	bsf HaveByte	;   

	goto rett	;


Rx_Err	
	bcf cren	;   
	bsf cren	;


rett
	MOVF PCLATH_TEMP, W 	; W, STATUS  PCLATH
	MOVWF PCLATH 		;
	SWAPF STATUS_TEMP,W 	;
	MOVWF STATUS		;
	SWAPF W_TEMP,F		;
	SWAPF W_TEMP,W		;
	retfie


;   .    8    , 
; PORTD.       ,   RD0
;:   Fig0 - Fig2,     w
Display
	movwf Latch		;  

	comf Latch,0		; Enable
	andwf PORTD,1		;

	movf Fig2,0		;    
	call Send8		;

	movf Fig1,0		;    
	call Send8		;

	movf Fig0,0		;    
	call Send8		;

	call Del500mcs		;  500 

	movf Latch,0		;
	iorwf PORTD,1		;
 
	return


;  
Send8	
	bcf Clk
	movwf IndVal
	movlw 8
	movwf CntInd
	
sendloop
	bcf Data_in 
	rlf IndVal,1
	btfsc STATUS,C
	bsf Data_in
	goto $+1	;
	goto $+1	;
	goto $+1	;
	bsf Clk
	goto $+1	;
	goto $+1	;
	goto $+1	;
	bcf Clk
	decfsz CntInd,1
	goto sendloop
	return


;  
;:    IndVal,     w
Control_MC14489
	movwf Latch
	comf Latch,0		; Enable
	andwf PORTD,1		;

	movf IndVal,0
	call Send8
	movf Latch,0		;Enable  1
	iorwf PORTD,1		;

	return




; 
Init
	BSF STATUS,RP0
 	BCF STATUS,IRP
	BCF STATUS,RP1
	MOVLW INIT_PORTA
	MOVWF TRISA^80h
	MOVLW INIT_PORTB
	MOVWF TRISB^80h
	MOVLW INIT_PORTC
	MOVWF TRISC^80h
	MOVLW INIT_PORTD
	MOVWF TRISD^80h
	MOVLW INIT_PORTE
	MOVWF TRISE^80h
	MOVLW INIT_OPTION
	MOVWF OPTION_REG^80h
	clrf ADCON1^80h

	movlw INIT_PIE1		
	movwf PIE1^80h
	clrf PIE2^80h

 	BCF STATUS,RP0

	movlw INIT_INTCON
	movwf INTCON
	movlw INIT_T1CON	
	movwf T1CON

	RETURN









;   500 
Del500mcs
	movlw .60
	movwf CntLo
	movlw 4
	movwf CntHi
_Del500	decfsz CntLo,1
	goto _Del500
	decfsz CntHi,1
	goto _Del500
	return


;   15 
Del15
	movlw .30		; 15
	movwf Temp		;
_15ms	call Del500mcs		;
	decfsz Temp,1		;
	goto _15ms		;
	return


	
;  
BtPress

	clrf ButPressed0	;   
	clrf ButPressed1	;


	bsf Line0
	nop
	call Del500mcs
	btfsc Col0
	bsf Bt15
	btfsc Col1
	bsf Bt14
	btfsc Col2
	bsf Bt13
	btfsc Col3
	bsf Bt12
	bcf Line0

	bsf Line1
	call Del500mcs
	nop
	btfsc Col0
	bsf Bt11
	btfsc Col1
	bsf Bt10
	btfsc Col2
	bsf Bt9
	btfsc Col3
	bsf Bt8
	bcf Line1

	bsf Line2
	nop
	call Del500mcs
	btfsc Col0
	bsf Bt7
	btfsc Col1
	bsf Bt6
	btfsc Col2
	bsf Bt5
	btfsc Col3
	bsf Bt4
	bcf Line2


	bsf Line3
	nop
	call Del500mcs
	btfsc Col0
	bsf Bt3
	btfsc Col1
	bsf Bt2
	btfsc Col2
	bsf Bt1
	btfsc Col3
	bsf Bt0
	bcf Line3

	bcf BtPrs		;      (.. ButPressed0  ButPressed1
	movf ButPressed0,1	;  0),     
	btfss STATUS,Z		;
	bsf BtPrs		;
	movf ButPressed1,0	;
	btfss STATUS,Z		;
	bsf BtPrs		;

	return





;/  Mul1Lo, Mul1Hi, ResHi  10.      ,   Temp.
; 1000 .
Div10
	movlw 6
	movwf CntHi
	clrf Temp2
	clrf Temp3
	clrf Temp4
	clrf Temp
shagn	call SHL4	;  4 
	
	clrf Temp1

subagn	movlw .10
	subwf Temp,1
	btfss STATUS,C
	goto less0
	incf Temp1,1	; >= 0
	goto subagn
less0	movlw .10
	addwf Temp,1
	
	bcf STATUS,C	;   4  
	movlw 4
	movwf CntLo
sh1	rlf Temp2,1
	rlf Temp3,1
	rlf Temp4,1
	decfsz CntLo,1
	goto sh1

	movf Temp1,0	;   
	iorwf Temp2,1	;

	decfsz CntHi,1	
	goto shagn	
	
	movf Temp4,0	;    Mul1Lo, Mul1Hi,ResHi
	movwf ResHi	;
	movf Temp3,0	;
	movwf Mul1Hi	;
	movf Temp2,0	;
	movwf Mul1Lo	;
	
	return


SHL4			
	bcf STATUS,C	;
	movlw 4		;
	movwf CntLo	;
sh	rlf Mul1Lo,1	;
	rlf Mul1Hi,1	;
	rlf ResHi,1	;
	rlf Temp,1	;
	decfsz CntLo,1	;
	goto sh		;
	return		;




;/  168.    Mul1Lo,Mul1Hi  Mul2
;   Mul1Lo, Mul1Hi, ResHi.
;  200 .
Mul16_8 
	clrf Temp
	clrf Temp1
	clrf Temp2
	clrf ResHi
	movlw 8
	movwf CntLo
Ml_3
	rrf Mul2,1
	btfss STATUS,C
	goto Ml_5
	movf Mul1Lo,0
	addwf Temp1,1
	btfss  STATUS,C
	goto Ml_1
	incfsz Temp2,1
	goto Ml_1
	incf ResHi,1
	
Ml_1
	movf Mul1Hi,0
	addwf Temp2,1
	btfss  STATUS,C
	goto Ml_2
	incf ResHi,1
	
Ml_2	movf Temp,0
	addwf ResHi,1
Ml_5
	decfsz CntLo,1
	goto Ml_4
	goto Fin_Mul

Ml_4	bcf STATUS,C
	rlf Mul1Lo,1
	rlf Mul1Hi,1
	rlf Temp,1
	goto Ml_3	
Fin_Mul
	movf Temp1,0
	movwf Mul1Lo
	movf Temp2,0
	movwf Mul1Hi
	return






;  
Init_SCI
	bsf spen		; SCI

	movlw ((Clock/DesiredBaudRate)/.64-1)		;  
	bsf STATUS,RP0		;
	movwf SPBRG^80h		;
	bcf brgh		;

	bcf sync		; 

; .
	bsf txen		; 
	bcf tx8_9		; 


; .    
	bcf STATUS,RP0
	bcf oerr		;  
	bcf rx8_9		; 
	bsf cren		; 
	return


SCI_Tx
;:  w (,   )
	movwf Tx_Byte
SCI_Tx_1
	btfss txif		;  TXREG
	goto SCI_Tx_1		;
	
	movf Tx_Byte,0		;  
	movwf TXREG		;
	return


SwpFig				;     
	movf Fig0,0
	movwf IndVal
	movf Fig1,0
	movwf Fig0
	movf IndVal,0
	movwf Fig1
	swapf Fig1,1
	swapf Fig0,1
	return




;   
Nabor			
	movwf TempNab		;   
	
	movf CntNab,0		;    ,   
	btfss STATUS,Z		;
	goto nz			;
	clrf FigNab0		;
	clrf FigNab1		;
	clrf FigNab2		;
	movlw 3			;
	movwf CntNab		;
nz
	movlw FigNab0		;      
	movwf FSR		;FigNab0
	decf CntNab,0		;
	addwf FSR,1		;
	movf TempNab,0		;
	movwf INDF		;

	decf CntNab,1		;   



	movf FigNab0,0		;    
	movwf Fig0		;
	swapf FigNab1,0		;
	iorwf Fig0,1		;
	movf FigNab2,0		;
	movwf Fig1		;

	movlw 0x60		;  ""
	iorwf Fig1,1		;


	call SwpFig		; Fig0... Fig2   
	movlw b'00000001'	;
	call Display		;

	return

;   TxByte  
Info
	movf TxByte,0		; TxByte  10,      
	movwf Mul1Lo		;Fig0      
	clrf Mul1Hi		;
	clrf ResHi		;
	call Div10		;
	movf Temp,0		;
	movwf Fig0		;


	call Div10		;    10,     
	swapf Temp,0		;Fig0      
	iorwf Fig0,1		;


	call Div10		;    10,     
	movf Temp,0		;Fig1      	
	movwf Fig1		;


	call SwpFig		;  
	movlw b'00000001'	;
	call Display		;
	return			;



Begin
			;	

	call Init		;
	call Init_SCI		; SCI

	clrf Flag



	bsf PORTD,0		; 
	bsf PORTD,1		;
	movlw b'01000011'	;    ,  - 
	movwf IndVal		;
	movlw b'00000001'	;
	call Control_MC14489	;
	movlw b'01000011'	;
	movwf IndVal		;
	movlw b'00000010'	;
	call Control_MC14489	;


	
	clrf Fig0		;   ,  
	clrf Fig1		;
	clrf Fig2		;
	movlw b'00000001'	;
	call Display		;


	clrf CntNab		;     
	clrf TxByte		;  

StrtProg			; 

	btfss HaveByte		;    RS232
	goto NoRS		;

	bcf HaveByte		; ,    


	movf RecByte,0		;    
	movwf Mul1Lo		; RecByte  10,      
	clrf Mul1Hi		;Fig0      
	clrf ResHi		;
	call Div10		;
	movf Temp,0		;
	movwf Fig0		;

	call Div10		;    10,     
	swapf Temp,0		;Fig0      
	iorwf Fig0,1		;
	
	call Div10		;    10,     
	movf Temp,0		;Fig1      
	movwf Fig1		;

	movlw 0x10		; ""   
	iorwf Fig1,1		;


	call SwpFig		;  
	movlw b'00000001'	;
	call Display		;
	clrf CntNab		;



NoRS

	
	call BtPress		;   
	btfss BtPrs		;
	goto StrtProg		;
	call Del15		; ,   15   


	btfss Bt0
	goto nbt0
	movlw 0			;  1
	call Nabor	

nbt0
	btfss Bt1
	goto nbt1
	movlw 1			;  2
	call Nabor	
nbt1
	btfss Bt2
	goto nbt2
	movlw 2			;  3
	call Nabor	
nbt2
	btfss Bt3
	goto nbt3
	movlw 3			;  4
	call Nabor	
nbt3
	btfss Bt4
	goto nbt4
	movlw 4			;  5
	call Nabor	
nbt4
	btfss Bt5
	goto nbt5
	movlw 5			;  6
	call Nabor	
nbt5
	btfss Bt6
	goto nbt6
	movlw 6			;  7
	call Nabor	
nbt6
	btfss Bt7
	goto nbt7
	movlw 7			;  8
	call Nabor	
nbt7
	btfss Bt8
	goto nbt8
	movlw 8			;  9
	call Nabor	
nbt8
	btfss Bt9
	goto nbt9
	movlw 9			;  10
	call Nabor		
nbt9
	btfss Bt10
	goto nbt10

	call Info		;  11,   .  TxByte
	clrf CntNab		;   

nbt10
	btfss Bt11
	goto nbt11
				;  12
	clrf CntNab		;   


				;  
	movf FigNab2,0		;  : FigNab2 * 100    TxByte
	movwf Mul1Lo		;
	clrf Mul1Hi		;
	movlw .100		;
	movwf Mul2		;
	call Mul16_8		;
	movf Mul1Lo,0		;
	movwf TxByte		;



	movf FigNab1,0		;  : FigNab1 * 10    TxByte
	movwf Mul1Lo		;
	clrf Mul1Hi		;
	movlw .10		;
	movwf Mul2		;
	call Mul16_8		;
	movf Mul1Lo,0		;
	addwf TxByte,1		;

	
	movf FigNab0,0		; FigNab0  TxByte
	addwf TxByte,1		;
	movf TxByte,0		;    
	call SCI_Tx		; 
	call Info		;
	goto StrtProg		;   

	
nbt11

	btfss Bt12
	goto nbt12
				;  13

	decf TxByte,1		;  TxByte
	call Info		;
	movf TxByte,0		;  
	call SCI_Tx		;
	clrf CntNab		;   		
	call Del15		;    
	goto StrtProg		;   


nbt12


	btfss Bt13
	goto nbt13

	decf TxByte,1		;  TxByte
	call Info		;
	movf TxByte,0		;  
	call SCI_Tx		;
	clrf CntNab		;   
	goto Wait_for_Release	;    



nbt13


	btfss Bt14
	goto nbt14


	incf TxByte,1		;  TxByte
	call Info		;
	movf TxByte,0		;  
	call SCI_Tx		;
	clrf CntNab		;   
	goto Wait_for_Release	;    


nbt14

	btfss Bt15
	goto nbt15


	incf TxByte,1		;  TxByte
	call Info		;
	movf TxByte,0		;  
	call SCI_Tx		;
	clrf CntNab		;   
	call Del15		;    
	goto StrtProg		;   



nbt15


Wait_for_Release		;  
	call BtPress
	btfsc BtPrs
	goto Wait_for_Release
	call Del15		;      
	goto StrtProg		;   



	


	end
